<?php
if (CheckAdmin()) {
	//Initialise the database...
	
	//Check for DB tables...
	$query = <<<EOT
CREATE TABLE IF NOT EXISTS `notifier_methods` (`code` varchar(60) NOT NULL, `parameters` varchar(256) NOT NULL) ENGINE=InnoDB DEFAULT CHARSET=latin1;
EOT;
	$db->query($query);

	$query = <<<EOT
CREATE TABLE IF NOT EXISTS `notifier_noticegroups` (
  `id` bigint(20) NOT NULL,
  `groupid` bigint(20) NOT NULL,
  UNIQUE KEY `id` (`id`,`groupid`),
  KEY `groupid` (`groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
EOT;
	$db->query($query);
	
	//echo $query;
	
$query = <<<EOT
CREATE TABLE IF NOT EXISTS `notifier_notices` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `assetid` bigint(20) NOT NULL,
  `propertyid` bigint(20) NOT NULL,
  `expr` varchar(80) NOT NULL,
  `state` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `assetid` (`assetid`),
  KEY `propertyid` (`propertyid`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1;
EOT;
	$db->query($query);
	
	$query = <<<EOT
CREATE TABLE IF NOT EXISTS `notifier_noticetext` (
  `noticeid` bigint(20) NOT NULL,
  `value` VARCHAR(40) NOT NULL,
  `message` VARCHAR(120) NOT NULL,
  UNIQUE KEY `byidval` (`noticeid`,`value`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
EOT;
	$db->query($query);
	
	require_once($installfolder.'/model/relationship.php');
	require_once($installfolder.'/model/property.php');

	$relationshipid = 0;
	
	//Check to see if the 'Organisation' relationship exists...
	$query = $db->query("SELECT id FROM relationships WHERE name='Organisation' AND style=3");
	if ($query !== FALSE)
	{
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$relationshipid = $row['id'];
		}
	}
	
	if ($relationshipid == 0)
	{
		//Create the required relationship...
		$relationshipid = Relationships::Create('Organisation','Supervised By','Supervises',3);
	}
	
	$result = 0;
	//Locate the 'Notification' tag....
	$query = $db->query("SELECT id FROM assets WHERE name LIKE 'Notification%' AND name <> 'Notification Groups' AND type=1");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];
	}
	
	if ($result == 0)
	{
		//Create Asset
		$result = Asset::Create('Notifications','This tag contains assets used as part of the notification addon',1);
		
		$rel = Relationships::GetRelationship(3);
		$root = $rel->GetRootAsset();
		
		//Link to root of the tag hierarchy
		$res = Relationships::Add($root,$result,3);
		
	}
	$notificationroot = $result;
	
	$result = 0;
	//Locate the 'Notification Group' tag....
	$query = $db->query("SELECT id FROM assets WHERE name='Notification Group' AND type=1");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];
	}
	
	if ($result == 0)
	{
		//Create Asset
		$result = Asset::Create('Notification Group','Assets under this tag are treated as notification groups',1);
		
		//Link to root of the tag hierarchy
		Relationships::Add($notificationroot,$result,3);
	}
	
	$result = 0;
	//Locate the 'Contact' tag....
	$query = $db->query("SELECT id FROM assets WHERE name='Contact' AND type=1");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];
	}
	
	if ($result == 0)
	{
		//Create Asset
		$result = Asset::Create('Contact','Assets under this tag are treated contacts and can receive notifications',1);
		
		//Link to root of the tag hierarchy
		Relationships::Add($notificationroot,$result,3);
	}
	$contactasset = $result;
	
	$result = 0;
	//Locate the 'Email Address' property....
	$query = $db->query("SELECT id FROM properties WHERE typename='EMAILADDRESS'");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];
	}
	
	if ($result == 0)
	{
		//Create Property
		$result = Properties::Create("Email Address","EMAILADDRESS","");
	}
	$eaddr = $result;
	
	$result = 0;
	//Locate the 'Mobile Number' property....
	$query = $db->query("SELECT id FROM properties WHERE typename='MOBILENUMBER'");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];	
	}
	
	if ($result == 0)
	{
		//Create Property
		$result = Properties::Create("Mobile Number","MOBILENUMBER","");
	}
	$mnumber = $result;
	
	$result = 0;
	//Locate the 'Contact Methods' property....
	$query = $db->query("SELECT id FROM properties WHERE typename='_NOTIFIERMETHODS'");
	if($row = $query->fetch(PDO::FETCH_ASSOC)) 
	{
		$result = $row['id'];
	}
	
	if ($result == 0)
	{
		//Create Property
		$nmethods = Properties::Create("Notification Methods","_NOTIFIERMETHODS","");
	}
	
	require_once($installfolder.'/model/asset.php');
	$ass = new Asset($contactasset);
	$ass->SetProperty($eaddr,"");
	$ass->SetProperty($mnumber,"");
	
	//Spinup service for this site
	
}
?>